#!/bin/sh
# --- T2-COPYRIGHT-NOTE-BEGIN ---
# T2 SDE: package/*/psi/langpack.sh
# Copyright (C) 2004 - 2022 The T2 SDE Project
# 
# This Copyright note is generated by scripts/Create-CopyPatch,
# more information can be found in the files COPYING and README.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2.
# --- T2-COPYRIGHT-NOTE-END ---

version=$( grep '^\[V\]' psi.desc | cut -d' ' -f2-)
url="http://psi-im.org/files/translation/$version"

# config.xml is not complete :\
#
#curl $url/config.xml | xml sel -t -m //psi/translation \
#	-v "concat('[D] 0 psi-0.9.3',substring(file,4),'_',file_version,'.qm !$url/',file,'.qm')" -n

# cache.html is uglier but seems complete
#
curl -B $url/cache.html | sed -e 's,.*Version: psi_,,g' -e "s,_${version}_, ,g" -e 's,<.*,,g' |
	sort | while read lang ver; do
echo "[D] 0 psi-${version}_${lang}_${ver}.qm !$url/psi_${lang}.qm"
done
